## redis 1.2.6

=== Makefile ===
# Redis Makefile
# Copyright (C) 2009 Salvatore Sanfilippo <antirez at gmail dot com>
# This file is released under the BSD license, see the COPYING file

uname_S := $(shell sh -c 'uname -s 2>/dev/null || echo not')
ifeq ($(uname_S),SunOS)
  CFLAGS?= -std=c99 -pedantic -O2 -Wall -W -D__EXTENSIONS__ -D_XPG6
  CCLINK?= -ldl -lnsl -lsocket -lm
else
  CFLAGS?= -std=c99 -pedantic -O2 -Wall -W $(ARCH) $(PROF)
  CCLINK?= -lm
endif
CCOPT= $(CFLAGS) $(CCLINK) $(ARCH) $(PROF)
DEBUG?= -g -rdynamic -ggdb 

OBJ = adlist.o ae.o anet.o dict.o redis.o sds.o zmalloc.o lzf_c.o lzf_d.o pqsort.o
BENCHOBJ = ae.o anet.o benchmark.o sds.o adlist.o zmalloc.o
CLIOBJ = anet.o sds.o adlist.o redis-cli.o zmalloc.o linenoise.o
STATOBJ = anet.o redis-stat.o sds.o zmalloc.o hiredis.o

PRGNAME = redis-server
BENCHPRGNAME = redis-benchmark
CLIPRGNAME = redis-cli
STATPRGNAME = redis-stat

all: redis-server redis-benchmark redis-cli redis-stat

# Deps (use make dep to generate this)
adlist.o: adlist.c adlist.h zmalloc.h
ae.o: ae.c ae.h zmalloc.h config.h ae_kqueue.c
ae_epoll.o: ae_epoll.c
ae_kqueue.o: ae_kqueue.c
ae_select.o: ae_select.c
anet.o: anet.c fmacros.h anet.h
benchmark.o: benchmark.c fmacros.h ae.h anet.h sds.h adlist.h zmalloc.h
dict.o: dict.c fmacros.h dict.h zmalloc.h
hiredis.o: hiredis.c hiredis.h sds.h anet.h zmalloc.h
linenoise.o: linenoise.c
lzf_c.o: lzf_c.c lzfP.h
lzf_d.o: lzf_d.c lzfP.h
pqsort.o: pqsort.c
redis-cli.o: redis-cli.c fmacros.h anet.h sds.h adlist.h zmalloc.h \
  linenoise.h
redis-stat.o: redis-stat.c fmacros.h sds.h zmalloc.h hiredis.h anet.h
redis.o: redis.c fmacros.h config.h redis.h ae.h sds.h anet.h dict.h \
  adlist.h zmalloc.h lzf.h pqsort.h staticsymbols.h
sds.o: sds.c sds.h zmalloc.h
zmalloc.o: zmalloc.c config.h

redis-server: $(OBJ)
	$(CC) -o $(PRGNAME) $(CCOPT) $(DEBUG) $(OBJ)
	@echo ""
	@echo "Hint: To run the test-redis.tcl script is a good idea."
	@echo "Launch the redis server with ./redis-server, then in another"
	@echo "terminal window enter this directory and run 'make test'."
	@echo ""

redis-benchmark: $(BENCHOBJ)
	$(CC) -o $(BENCHPRGNAME) $(CCOPT) $(DEBUG) $(BENCHOBJ)

redis-cli: $(CLIOBJ)
	$(CC) -o $(CLIPRGNAME) $(CCOPT) $(DEBUG) $(CLIOBJ)

redis-stat: $(STATOBJ)
	$(CC) -o $(STATPRGNAME) $(CCOPT) $(DEBUG) $(STATOBJ)

.c.o:
	$(CC) -c $(CFLAGS) $(DEBUG) $(COMPILE_TIME) $<

clean:
	rm -rf $(PRGNAME) $(BENCHPRGNAME) $(CLIPRGNAME) $(STATPRGNAME) *.o *.gcda *.gcno *.gcov

dep:
	$(CC) -MM *.c

staticsymbols:
	tclsh utils/build-static-symbols.tcl > staticsymbols.h

test:
	tclsh test-redis.tcl

bench:
	./redis-benchmark

log:
	git log '--pretty=format:%ad %s' --date=short > Changelog

32bit:
	make ARCH="-m32"

gprof:
	make PROF="-pg"

gcov:
	make PROF="-fprofile-arcs -ftest-coverage"

32bitgprof:
	make PROF="-pg" ARCH="-arch i386"

## redis 1.2.0

=== debian/changelog ===
redis (2:1.2.0-1) unstable; urgency=low

  * New upstream stable release.
  * Switch to dpkg-source 3.0 (quilt) format.
  * Patch out printing of pid on startup.

 -- Chris Lamb <lamby@debian.org>  Thu, 14 Jan 2010 15:50:36 +0000

redis (2:1.1.95~beta-2) unstable; urgency=low

  * Set source section to "database" from "misc".
  * Add redis-cli binary to "redis-server" package.

 -- Chris Lamb <lamby@debian.org>  Wed, 13 Jan 2010 23:36:30 +0000

redis (2:1.1.95~beta-1) unstable; urgency=low

  * New upstream release.
  * Sync debian/redis.conf with upstream version (new "rdbcompression" and
    "masterauth" commands).

 -- Chris Lamb <lamby@debian.org>  Sun, 10 Jan 2010 22:59:06 +0000

redis (2:1.1.90~beta-1) unstable; urgency=low

  * New upstream release:
    - Bump the epoch as dpkg considers 1.1.90 to be less than 1.02.
    - Sync redis.conf
  * Don't build client libraries anymore; not part of the upstream tarball
    anymore.
  * Don't export CFLAGS from debian/rules to prevent FTBFS when dpkg-provided
    CFLAGS does not include --std=c99.
  * Modify debian/watch to consider "-beta" the same as "~beta" for correct
    dpkg ordering.

 -- Chris Lamb <lamby@debian.org>  Sat, 05 Dec 2009 22:10:32 +0000

redis (1:1.02-1) unstable; urgency=low

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Fri, 23 Oct 2009 16:26:45 +0100

redis (1:1.01-1) unstable; urgency=low

  * New upstream release.
    - "maxmemory now works well on 64bit systems with > 4GB of RAM"

 -- Chris Lamb <lamby@debian.org>  Tue, 22 Sep 2009 21:53:48 +0100

redis (1:1.0-1) unstable; urgency=low

  * New upstream release.
  * Bump Standards-Version to 3.8.3.
  * Drop patch system:
    - 01-recommend-sysctl-conf.diff; applied upstream.
    - 02-warn-after-daemonising.diff; applied upstream.
    - 03-only-mangle-trace-on-ia64-and-x86.diff; applied upstream.
    - Drop quilt Build-Depends and remove patches/series.
  * Use "override_dh_auto_clean" instead of "clean" target.

 -- Chris Lamb <lamby@debian.org>  Tue, 08 Sep 2009 22:09:19 +0100

redis (1:0.900-3) unstable; urgency=low

  * Actually add architecture patch introducted in 1:0.900-2 to quilt 'series'
    (Closes: #533763)
  * Correct "/proc/sys/vm/overcommit_memory" message to print the correct
    string to add to sysctl.conf.

 -- Chris Lamb <lamby@debian.org>  Thu, 25 Jun 2009 12:13:02 +0100

redis (1:0.900-2) unstable; urgency=low

  * Add patch to avoid mangling the stacktrace on SIGSEGV using X86-specific
    ucontext struct, etc. (Closes: #533763)
  * Bump Standards-Version to 3.8.2.

 -- Chris Lamb <lamby@debian.org>  Wed, 24 Jun 2009 23:54:42 +0100

redis (1:0.900-1) unstable; urgency=low

  * New upstream release.
    - Update debian/redis.conf
  * Update versionmangle in debian/watch.
  * "/proc/sys/vm/overcommit_memory" message:
    - Recommend modifying /etc/sysctl.conf instead of using "boot scripts"
    - Warn after daemonising to avoid message being spammed on every boot.

 -- Chris Lamb <lamby@debian.org>  Wed, 17 Jun 2009 10:39:57 +0100

redis (1:0.100-1) unstable; urgency=low

  * New upstream release.
    - Update debian/redis.conf

 -- Chris Lamb <lamby@debian.org>  Thu, 28 May 2009 00:31:37 +0100

redis (1:0.096-1) unstable; urgency=low

  * New upstream version.

 -- Chris Lamb <lamby@debian.org>  Sat, 09 May 2009 22:16:13 +0100

redis (1:0.095-1) unstable; urgency=low

  * New upstream version.

 -- Chris Lamb <lamby@debian.org>  Sat, 09 May 2009 12:50:26 +0100

redis (1:0.094-3) unstable; urgency=low

  * Really upload to unstable - I give "debchange -r" less credit than it
    deserves.

 -- Chris Lamb <lamby@debian.org>  Thu, 07 May 2009 22:02:24 +0100

redis (1:0.094-2) experimental; urgency=low

  * Upload to unstable.
  * Add libredis-perl package.

 -- Chris Lamb <lamby@debian.org>  Wed, 06 May 2009 00:19:35 +0100

redis (1:0.094-1) experimental; urgency=low

  * New upstream release.
  * Place libphp-redis package into 'php' section.
  * Update debian/copyright with new libraries.
  * Correct Vcs-Browser location.

 -- Chris Lamb <lamby@debian.org>  Wed, 06 May 2009 00:08:26 +0100

redis (1.0~beta8-1) experimental; urgency=low

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Tue, 24 Mar 2009 22:30:02 +0000

redis (1.0~beta7-1) experimental; urgency=low

  * Initial release. (Closes: #518700)

 -- Chris Lamb <lamby@debian.org>  Fri, 20 Mar 2009 00:37:15 +0000

=== debian/control ===
Source: redis
Section: database
Priority: optional
Maintainer: Chris Lamb <lamby@debian.org>
Build-Depends: debhelper (>= 7.0.50)
Standards-Version: 3.8.3
Homepage: http://code.google.com/p/redis/
Vcs-Git: git://git.chris-lamb.co.uk/debian/pkg-redis.git
Vcs-Browser: http://git.chris-lamb.co.uk/?p=debian/pkg-redis.git

Package: redis-server
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, adduser
Description: Persistent key-value database with network interface
 Redis is a key-value database in a similar vein to memcache but the dataset
 is non-volatile. Redis additionally provides native support for atomically
 manipulating and querying data structures such as lists and sets.
 .
 The dataset is stored entirely in memory and periodically flushed to disk.

Package: redis-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Persistent key-value database with network interface (Documentation)
 Redis is a key-value database in a similar vein to memcache but the dataset
 is non-volatile. Redis additionally provides native support for atomically
 manipulating and querying data structures such as lists and sets.
 .
 This package contains the documentation for Redis.

## redis 1.2.6

=== debian/changelog ===
redis (2:1.2.6-1) unstable; urgency=low

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Tue, 30 Mar 2010 14:13:52 +0100

redis (2:1.2.5-1) unstable; urgency=low

  * New upstream release.
  * Drop 02-fix-segfault-indupClientReplyValue.diff; applied upstream via
    <http://code.google.com/p/redis/issues/detail?id=177>.

 -- Chris Lamb <lamby@debian.org>  Thu, 11 Mar 2010 21:34:37 +0000

redis (2:1.2.4-1) unstable; urgency=low

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Tue, 09 Mar 2010 16:18:19 +0000

redis (2:1.2.3-1) unstable; urgency=low

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Tue, 02 Mar 2010 16:45:07 +0000

redis (2:1.2.2-2) unstable; urgency=low

  * Really fix segfault in dupClientReplyValue. (Closes: #570371)

 -- Chris Lamb <lamby@debian.org>  Fri, 19 Feb 2010 09:16:48 +0000

redis (2:1.2.2-1) unstable; urgency=low

  * New upstream release.
    - Fixes segfault in dupClientReplyValue. Thanks to Hirling Endre
      <endre@dawn.royalcomp.hu> (Closes: #570371)

 -- Chris Lamb <lamby@debian.org>  Thu, 18 Feb 2010 22:02:10 +0000

redis (2:1.2.1-1) unstable; urgency=low

  * New upstream release.
  * Add Bash completion script for redis-cli by Steve Kemp <skx@debian.org>.
    (Closes: #565358)
  * Bump Standards-Version to 3.8.4.
  * Add $remote_fs to LSB "Required-{Start,Stop}" initscript headers.

 -- Chris Lamb <lamby@debian.org>  Tue, 09 Feb 2010 14:37:32 +0000

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Chris Lamb <lamby@debian.org>
 Build-Depends: debhelper (>= 7.0.50)
-Standards-Version: 3.8.3
+Standards-Version: 3.8.4
 Homepage: http://code.google.com/p/redis/
 Vcs-Git: git://git.chris-lamb.co.uk/debian/pkg-redis.git
 Vcs-Browser: http://git.chris-lamb.co.uk/?p=debian/pkg-redis.git

=== debian/watch ===
version=3
opts="uversionmangle=s/-beta/~beta/" http://code.google.com/p/redis/downloads/list http://redis.googlecode.com/files/redis-(.*).tar.gz

## redis 2.0.0~rc2

=== debian/changelog ===
redis (2:2.0.0~rc2-1) experimental; urgency=low

  * New upstream RC release.

 -- Chris Lamb <lamby@debian.org>  Thu, 01 Jul 2010 23:15:02 +0100

redis (2:2.0.0~rc1-2) experimental; urgency=low

  * Add 'status' command to initscript.
  * Add redis-benchmark (and manpage) to package. (Closes: #587395)

 -- Chris Lamb <lamby@debian.org>  Mon, 28 Jun 2010 11:02:31 +0100

redis (2:2.0.0~rc1-1) experimental; urgency=low

  * New upstream release candidate.
  * Remove '01-dont-print-pid-on-startup.diff' patch.
  * Update local copy of redis.conf.

 -- Chris Lamb <lamby@debian.org>  Tue, 01 Jun 2010 10:51:05 +0100

=== debian/rules ===
#!/usr/bin/make -f

unexport CFLAGS

%:
	dh $@

override_dh_auto_test:
	# Testsuite requires working TCP/IP and a non-interactive mode

=== debian/watch ===
version=3
opts="uversionmangle=s/-rc/~rc/" http://googlecode.debian.net/p/redis /p/redis/redis-(.*).tar.gz

## redis 2.0.1

=== debian/changelog ===
redis (2:2.0.1-2) unstable; urgency=low

  * Upload to unstable.

 -- Chris Lamb <lamby@debian.org>  Fri, 10 Sep 2010 14:49:30 +0100

redis (2:2.0.1-1) experimental; urgency=low

  * New upstream release.
  * Update debian/watch to not match old tarballs.
  * Upstream now ships an install target; let's just ignore it for now.

 -- Chris Lamb <lamby@debian.org>  Fri, 10 Sep 2010 14:40:01 +0100

redis (2:2.0.0~rc4-1) experimental; urgency=low

  * New upstream RC release.
  * Bump Standards-Version to 3.9.1.
  * Remove mkreleasehdr.sh when building to avoid debian diff - it will
    regenerate release.h with different contents.

 -- Chris Lamb <lamby@debian.org>  Thu, 29 Jul 2010 09:13:31 -0400

redis (2:2.0.0~rc3-1) experimental; urgency=low

  * New upstream RC release.
  * Bump Standards-Version to 3.9.0.

 -- Chris Lamb <lamby@debian.org>  Fri, 23 Jul 2010 11:59:16 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Chris Lamb <lamby@debian.org>
 Build-Depends: debhelper (>= 7.0.50)
-Standards-Version: 3.8.4
+Standards-Version: 3.9.1
 Homepage: http://code.google.com/p/redis/
 Vcs-Git: git://git.chris-lamb.co.uk/debian/pkg-redis.git
 Vcs-Browser: http://git.chris-lamb.co.uk/?p=debian/pkg-redis.git

=== debian/rules ===
--- 
+++ 
@@ -7,3 +7,9 @@
 
 override_dh_auto_test:
 	# Testsuite requires working TCP/IP and a non-interactive mode
+
+override_dh_auto_install:
+
+override_dh_auto_clean:
+	rm -rf mkreleasehdr.sh
+	dh_auto_clean

=== debian/watch ===
version=3
opts="uversionmangle=s/-rc/~rc/;s/^beta/0+beta/" http://googlecode.debian.net/p/redis /p/redis/redis-(.*).tar.gz

## redis 2.2.11

=== debian/changelog ===
redis (2:2.2.11-3) unstable; urgency=low

  * Change default loglevel to "notice".
  * Wait forever for redis to stop - only waiting 10 seconds could cause data
    loss.
  * Set a proper default location for socket file. (Closes: #632931)

 -- Chris Lamb <lamby@debian.org>  Mon, 18 Jul 2011 13:25:16 +0100

redis (2:2.2.11-2) unstable; urgency=low

  * Fix FTBFS on kfreebsd. Thanks to Christoph Egger <christoph@debian.org> for
    the patch. (Closes: #632499)
  * Ship redis-check-aof and redis-check-dump. (Closes: #632858)

 -- Chris Lamb <lamby@debian.org>  Wed, 06 Jul 2011 22:36:18 +0100

redis (2:2.2.11-1) unstable; urgency=low

  * New upstream release.
  * Correct spelling of "Description" in patch system.

 -- Chris Lamb <lamby@debian.org>  Sat, 02 Jul 2011 00:43:37 +0100

redis (2:2.2.10-1) unstable; urgency=low

  * New upstream release.
  * Bump Standards-Version to 3.9.2.

 -- Chris Lamb <lamby@debian.org>  Sat, 18 Jun 2011 14:53:41 +0100

redis (2:2.2.8-1) unstable; urgency=low

  * New upstream release.
  * Add patch from Ubuntu to fix FTBFS due to --as-needed linking.
    Thanks to Nigel Babu <nigelbabu@ubuntu.com>. (Closes: #628056)

 -- Chris Lamb <lamby@debian.org>  Tue, 07 Jun 2011 16:43:58 +0100

redis (2:2.2.5-1) unstable; urgency=low

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Mon, 25 Apr 2011 14:04:29 +0100

redis (2:2.2.4-1) unstable; urgency=low

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Fri, 22 Apr 2011 14:05:43 +0100

redis (2:2.2.2-1) unstable; urgency=low

  * New upstream release.
  * Use userdel over deluser to prevent problems when purging package.
    (Closes: #618326)

 -- Chris Lamb <lamby@debian.org>  Tue, 15 Mar 2011 11:13:21 +0000

redis (2:2.2.1-1) unstable; urgency=low

  * New upstream release. (Closes: #604076)
  * Update install paths.

 -- Chris Lamb <lamby@debian.org>  Thu, 24 Feb 2011 19:39:43 +0000

## redis 2.2.12

=== deps/hiredis/Makefile ===
# Hiredis Makefile
# Copyright (C) 2010 Salvatore Sanfilippo <antirez at gmail dot com>
# This file is released under the BSD license, see the COPYING file

OBJ = net.o hiredis.o sds.o async.o
BINS = hiredis-example hiredis-test

uname_S := $(shell sh -c 'uname -s 2>/dev/null || echo not')
OPTIMIZATION?=-O3
ifeq ($(uname_S),SunOS)
  CFLAGS?=-std=c99 -pedantic $(OPTIMIZATION) -fPIC -Wall -W -D__EXTENSIONS__ -D_XPG6 $(ARCH) $(PROF)
  CCLINK?=-ldl -lnsl -lsocket -lm -lpthread
  LDFLAGS?=-L. -Wl,-R,.
  DYLIBNAME?=libhiredis.so
  DYLIB_MAKE_CMD?=$(CC) -G -o ${DYLIBNAME} ${OBJ}
  STLIBNAME?=libhiredis.a
  STLIB_MAKE_CMD?=ar rcs ${STLIBNAME} ${OBJ}
else
ifeq ($(uname_S),Darwin)
  CFLAGS?=-std=c99 -pedantic $(OPTIMIZATION) -fPIC -Wall -W -Wwrite-strings $(ARCH) $(PROF)
  CCLINK?=-lm -pthread
  LDFLAGS?=-L. -Wl,-rpath,.
  OBJARCH?=-arch i386 -arch x86_64
  DYLIBNAME?=libhiredis.dylib
  DYLIB_MAKE_CMD?=libtool -dynamic -o ${DYLIBNAME} -lm ${DEBUG} - ${OBJ}
  STLIBNAME?=libhiredis.a
  STLIB_MAKE_CMD?=libtool -static -o ${STLIBNAME} - ${OBJ}
else
  CFLAGS?=-std=c99 -pedantic $(OPTIMIZATION) -fPIC -Wall -W -Wwrite-strings $(ARCH) $(PROF)
  CCLINK?=-lm -pthread
  LDFLAGS?=-L. -Wl,-rpath,.
  DYLIBNAME?=libhiredis.so
  DYLIB_MAKE_CMD?=gcc -shared -Wl,-soname,${DYLIBNAME} -o ${DYLIBNAME} ${OBJ}
  STLIBNAME?=libhiredis.a
  STLIB_MAKE_CMD?=ar rcs ${STLIBNAME} ${OBJ}
endif
endif

CCOPT= $(CFLAGS) $(CCLINK)
DEBUG?= -g -ggdb

PREFIX?= /usr/local
INSTALL_INC= $(PREFIX)/include/hiredis
INSTALL_LIB= $(PREFIX)/lib
INSTALL= cp -a

all: ${DYLIBNAME} ${BINS}

# Deps (use make dep to generate this)
net.o: net.c fmacros.h net.h
async.o: async.c async.h hiredis.h sds.h util.h
example.o: example.c hiredis.h
hiredis.o: hiredis.c hiredis.h net.h sds.h util.h
sds.o: sds.c sds.h
test.o: test.c hiredis.h

${DYLIBNAME}: ${OBJ}
	${DYLIB_MAKE_CMD}

${STLIBNAME}: ${OBJ}
	${STLIB_MAKE_CMD}

dynamic: ${DYLIBNAME}
static: ${STLIBNAME}

# Binaries:
hiredis-example-libevent: example-libevent.c adapters/libevent.h ${DYLIBNAME}
	$(CC) -o $@ $(CCOPT) $(DEBUG) $(LDFLAGS) -lhiredis -levent example-libevent.c

hiredis-example-libev: example-libev.c adapters/libev.h ${DYLIBNAME}
	$(CC) -o $@ $(CCOPT) $(DEBUG) $(LDFLAGS) -lhiredis -lev example-libev.c

ifndef AE_DIR
hiredis-example-ae:
	@echo "Please specify AE_DIR (e.g. <redis repository>/src)"
	@false
else
hiredis-example-ae: example-ae.c adapters/ae.h ${DYLIBNAME}
	$(CC) -o $@ $(CCOPT) $(DEBUG) -I$(AE_DIR) $(LDFLAGS) -lhiredis example-ae.c $(AE_DIR)/ae.o $(AE_DIR)/zmalloc.o
endif

hiredis-%: %.o ${DYLIBNAME}
	$(CC) -o $@ $(CCOPT) $(DEBUG) $(LDFLAGS) -lhiredis $<

test: hiredis-test
	./hiredis-test

.c.o:
	$(CC) -c $(CFLAGS) $(OBJARCH) $(DEBUG) $(COMPILE_TIME) $<

clean:
	rm -rf ${DYLIBNAME} ${STLIBNAME} $(BINS) hiredis-example* *.o *.gcda *.gcno *.gcov

dep:
	$(CC) -MM *.c

install: ${DYLIBNAME} ${STLIBNAME}
	mkdir -p $(INSTALL_INC) $(INSTALL_LIB)
	$(INSTALL) hiredis.h async.h adapters $(INSTALL_INC)
	$(INSTALL) ${DYLIBNAME} ${STLIBNAME} $(INSTALL_LIB)

32bit:
	@echo ""
	@echo "WARNING: if it fails under Linux you probably need to install libc6-dev-i386"
	@echo ""
	$(MAKE) ARCH="-m32"

gprof:
	$(MAKE) PROF="-pg"

gcov:
	$(MAKE) PROF="-fprofile-arcs -ftest-coverage"

noopt:
	$(MAKE) OPTIMIZATION=""

=== debian/changelog ===
redis (2:2.2.12-1build1) precise; urgency=low

  * No-change rebuild to drop spurious libsfgcc1 dependency on armhf.

 -- Adam Conrad <adconrad@0c3.net>  Fri, 02 Dec 2011 21:18:25 -0700

redis (2:2.2.12-1) unstable; urgency=low

  * New upstream release.
  * Move runtime files to /var/run/redis/ and set that as default location for
    socket file. Thanks to Sandro Tosi <morph@debian.org>. (Closes: #632931)
  * Refresh fix-link-ordering patch.
  * Use "defined(__linux__) || defined(__GLIBC__)" for kfreebsd compatibility.
    Thanks to Robert Millan <rmh@debian.org>. (Closes: #632499)

 -- Chris Lamb <lamby@debian.org>  Wed, 27 Jul 2011 19:20:26 +0200

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,10 @@
 Priority: optional
 Maintainer: Chris Lamb <lamby@debian.org>
 Build-Depends: debhelper (>= 7.0.50)
-Standards-Version: 3.9.1
-Homepage: http://code.google.com/p/redis/
-Vcs-Git: git://git.chris-lamb.co.uk/debian/pkg-redis.git
-Vcs-Browser: http://git.chris-lamb.co.uk/?p=debian/pkg-redis.git
+Standards-Version: 3.9.2
+Homepage: http://redis.io/
+Vcs-Git: git://github.com/lamby/pkg-redis.git
+Vcs-Browser: https://github.com/lamby/pkg-redis
 
 Package: redis-server
 Architecture: any

## redis 2.4.2

=== debian/changelog ===
redis (2:2.4.2-2) unstable; urgency=low

  * Fix test suite on sparc (Closes: #647627)

 -- Chris Lamb <lamby@debian.org>  Wed, 07 Dec 2011 16:55:23 +0000

redis (2:2.4.2-1) unstable; urgency=low

  * New upstream release.
  * /etc/init.d/redis-server fixes:
    - Send TERM, not QUIT signal.
    - Sleep 1 second after exiting as although the process has disappeared the
      server socket is somehow still in use which causes the start to fail.
  * Drop 01-fix-link-ordering patch; fixed upstream.
    <http://code.google.com/p/redis/issues/detail?id=562>.
  * Update 02-fix-ftbfs-on-kfreebsd.
  * Drop redis-doc package now that upstream no longer ship documentation.

 -- Chris Lamb <lamby@debian.org>  Wed, 16 Nov 2011 16:00:23 +0000

## redis 2.4.5

=== deps/hiredis/Makefile ===
--- 
+++ 
@@ -17,7 +17,7 @@
   STLIB_MAKE_CMD?=ar rcs ${STLIBNAME} ${OBJ}
 else
 ifeq ($(uname_S),Darwin)
-  CFLAGS?=-std=c99 -pedantic $(OPTIMIZATION) -fPIC -Wall -W -Wwrite-strings $(ARCH) $(PROF)
+  CFLAGS?=-std=c99 -pedantic $(OPTIMIZATION) -fPIC -Wall -W -Wstrict-prototypes -Wwrite-strings $(ARCH) $(PROF)
   CCLINK?=-lm -pthread
   LDFLAGS?=-L. -Wl,-rpath,.
   OBJARCH?=-arch i386 -arch x86_64
@@ -26,7 +26,7 @@
   STLIBNAME?=libhiredis.a
   STLIB_MAKE_CMD?=libtool -static -o ${STLIBNAME} - ${OBJ}
 else
-  CFLAGS?=-std=c99 -pedantic $(OPTIMIZATION) -fPIC -Wall -W -Wwrite-strings $(ARCH) $(PROF)
+  CFLAGS?=-std=c99 -pedantic $(OPTIMIZATION) -fPIC -Wall -W -Wstrict-prototypes -Wwrite-strings $(ARCH) $(PROF)
   CCLINK?=-lm -pthread
   LDFLAGS?=-L. -Wl,-rpath,.
   DYLIBNAME?=libhiredis.so
@@ -48,7 +48,7 @@
 
 # Deps (use make dep to generate this)
 net.o: net.c fmacros.h net.h
-async.o: async.c async.h hiredis.h sds.h util.h
+async.o: async.c async.h hiredis.h sds.h util.h dict.c dict.h
 example.o: example.c hiredis.h
 hiredis.o: hiredis.c hiredis.h net.h sds.h util.h
 sds.o: sds.c sds.h

=== debian/changelog ===
redis (2:2.4.5-1) unstable; urgency=low

  * New upstream version (Closes: #655416)
  * Use system jemalloc. (Closes: #654900, #654902)

 -- Chris Lamb <lamby@debian.org>  Wed, 11 Jan 2012 12:30:27 +0000

=== debian/rules ===
--- 
+++ 
@@ -10,6 +10,6 @@
 
 override_dh_auto_install:
 
-override_dh_auto_clean:
-	rm -rf mkreleasehdr.sh
-	dh_auto_clean
+clean:
+	dh $@
+	rm -f src/release.h

## redis 2.4.8

=== debian/changelog ===
redis (2:2.4.8-1) unstable; urgency=low

  * New upstream release.
  * Fix debian/watch (Closes: #661919)
  * Don't use jemalloc on archs not supporting it (Closes: #661354)

 -- Chris Lamb <lamby@debian.org>  Sun, 11 Mar 2012 22:19:51 +0000

## redis 2.4.14

=== Makefile ===
# Top level makefile, the real shit is at src/Makefile

TARGETS=32bit noopt test

all:
	cd src && $(MAKE) $@

install: dummy
	cd src && $(MAKE) $@

clean:
	cd src && $(MAKE) $@
	cd deps/hiredis && $(MAKE) $@
	cd deps/linenoise && $(MAKE) $@
	-(cd deps/jemalloc && $(MAKE) distclean)

distclean: clean

$(TARGETS):
	cd src && $(MAKE) $@

src/help.h:
	@./utils/generate-command-help.rb > $@

dummy:

=== src/Makefile ===
# Redis Makefile
# Copyright (C) 2009 Salvatore Sanfilippo <antirez at gmail dot com>
# This file is released under the BSD license, see the COPYING file

release_hdr := $(shell sh -c './mkreleasehdr.sh')
uname_S := $(shell sh -c 'uname -s 2>/dev/null || echo not')
OPTIMIZATION?=-O2

CCCOLOR="\033[34m"
LINKCOLOR="\033[34;1m"
SRCCOLOR="\033[33m"
BINCOLOR="\033[37;1m"
MAKECOLOR="\033[32;1m"
ENDCOLOR="\033[0m"

ifndef V
QUIET_CC = @printf '    %b %b\n' $(CCCOLOR)CC$(ENDCOLOR) $(SRCCOLOR)$@$(ENDCOLOR);
QUIET_LINK = @printf '    %b %b\n' $(LINKCOLOR)LINK$(ENDCOLOR) $(BINCOLOR)$@$(ENDCOLOR);
endif

ifeq ($(uname_S),Linux)
  ifneq ($(FORCE_LIBC_MALLOC),yes)
    USE_JEMALLOC=yes
  endif
endif

ifeq ($(uname_S),SunOS)
  CFLAGS?=-std=c99 -pedantic $(OPTIMIZATION) -Wall -W -D__EXTENSIONS__ -D_XPG6
  CCLINK?=-ldl -lnsl -lsocket -lm -lpthread
  DEBUG?=-g -ggdb
else
  CFLAGS?=-std=c99 -pedantic $(OPTIMIZATION) -Wall -W $(ARCH) $(PROF)
  CCLINK?=-lm -pthread
  DEBUG?=-g -rdynamic -ggdb
endif

ifeq ($(USE_TCMALLOC),yes)
  ALLOC_DEP=
  ALLOC_LINK=-ltcmalloc
  ALLOC_FLAGS=-DUSE_TCMALLOC
endif

ifeq ($(USE_TCMALLOC_MINIMAL),yes)
  ALLOC_DEP=
  ALLOC_LINK=-ltcmalloc_minimal
  ALLOC_FLAGS=-DUSE_TCMALLOC
endif

ifeq ($(USE_JEMALLOC),yes)
  ALLOC_DEP=../deps/jemalloc/lib/libjemalloc.a
  ALLOC_LINK=$(ALLOC_DEP) -ldl
  ALLOC_FLAGS=-DUSE_JEMALLOC -I../deps/jemalloc/include
endif

CCOPT= $(CFLAGS) $(ARCH) $(PROF)

PREFIX?=/usr/local
INSTALL_BIN= $(PREFIX)/bin
INSTALL= cp -pf

OBJ = adlist.o ae.o anet.o dict.o redis.o sds.o zmalloc.o lzf_c.o lzf_d.o pqsort.o zipmap.o sha1.o ziplist.o release.o networking.o util.o object.o db.o replication.o rdb.o t_string.o t_list.o t_set.o t_zset.o t_hash.o config.o aof.o vm.o pubsub.o multi.o debug.o sort.o intset.o syncio.o slowlog.o bio.o memtest.o
BENCHOBJ = ae.o anet.o redis-benchmark.o sds.o adlist.o zmalloc.o
CLIOBJ = anet.o sds.o adlist.o redis-cli.o zmalloc.o release.o ae.o
CHECKDUMPOBJ = redis-check-dump.o lzf_c.o lzf_d.o
CHECKAOFOBJ = redis-check-aof.o

PRGNAME = redis-server
BENCHPRGNAME = redis-benchmark
CLIPRGNAME = redis-cli
CHECKDUMPPRGNAME = redis-check-dump
CHECKAOFPRGNAME = redis-check-aof

all: redis-benchmark redis-cli redis-check-dump redis-check-aof redis-server
	@echo ""
	@echo "Hint: To run 'make test' is a good idea ;)"
	@echo ""

# Deps (use make dep to generate this)
adlist.o: adlist.c adlist.h zmalloc.h
ae.o: ae.c ae.h zmalloc.h config.h ae_kqueue.c
ae_epoll.o: ae_epoll.c
ae_kqueue.o: ae_kqueue.c
ae_select.o: ae_select.c
anet.o: anet.c fmacros.h anet.h
aof.o: aof.c redis.h fmacros.h config.h ae.h sds.h dict.h adlist.h \
  zmalloc.h anet.h zipmap.h ziplist.h intset.h version.h util.h
bio.o: bio.c redis.h fmacros.h config.h ae.h sds.h dict.h adlist.h \
  zmalloc.h anet.h zipmap.h ziplist.h intset.h version.h util.h bio.h
config.o: config.c redis.h fmacros.h config.h ae.h sds.h dict.h adlist.h \
  zmalloc.h anet.h zipmap.h ziplist.h intset.h version.h util.h
db.o: db.c redis.h fmacros.h config.h ae.h sds.h dict.h adlist.h \
  zmalloc.h anet.h zipmap.h ziplist.h intset.h version.h util.h
debug.o: debug.c redis.h fmacros.h config.h ae.h sds.h dict.h adlist.h \
  zmalloc.h anet.h zipmap.h ziplist.h intset.h version.h util.h sha1.h
dict.o: dict.c fmacros.h dict.h zmalloc.h
endian.o: endian.c
intset.o: intset.c intset.h zmalloc.h endian.h
lzf_c.o: lzf_c.c lzfP.h
lzf_d.o: lzf_d.c lzfP.h
multi.o: multi.c redis.h fmacros.h config.h ae.h sds.h dict.h adlist.h \
  zmalloc.h anet.h zipmap.h ziplist.h intset.h version.h util.h
networking.o: networking.c redis.h fmacros.h config.h ae.h sds.h dict.h \
  adlist.h zmalloc.h anet.h zipmap.h ziplist.h intset.h version.h util.h
object.o: object.c redis.h fmacros.h config.h ae.h sds.h dict.h adlist.h \
  zmalloc.h anet.h zipmap.h ziplist.h intset.h version.h util.h
pqsort.o: pqsort.c
pubsub.o: pubsub.c redis.h fmacros.h config.h ae.h sds.h dict.h adlist.h \
  zmalloc.h anet.h zipmap.h ziplist.h intset.h version.h util.h
rdb.o: rdb.c redis.h fmacros.h config.h ae.h sds.h dict.h adlist.h \
  zmalloc.h anet.h zipmap.h ziplist.h intset.h version.h util.h lzf.h
redis-benchmark.o: redis-benchmark.c fmacros.h ae.h \
  ../deps/hiredis/hiredis.h sds.h adlist.h zmalloc.h
redis-check-aof.o: redis-check-aof.c fmacros.h config.h
redis-check-dump.o: redis-check-dump.c lzf.h
redis-cli.o: redis-cli.c fmacros.h version.h ../deps/hiredis/hiredis.h \
  sds.h zmalloc.h ../deps/linenoise/linenoise.h help.h
redis.o: redis.c redis.h fmacros.h config.h ae.h sds.h dict.h adlist.h \
  zmalloc.h anet.h zipmap.h ziplist.h intset.h version.h util.h slowlog.h \
  bio.h
release.o: release.c release.h
replication.o: replication.c redis.h fmacros.h config.h ae.h sds.h dict.h \
  adlist.h zmalloc.h anet.h zipmap.h ziplist.h intset.h version.h util.h
sds.o: sds.c sds.h zmalloc.h
sha1.o: sha1.c sha1.h
slowlog.o: slowlog.c redis.h fmacros.h config.h ae.h sds.h dict.h \
  adlist.h zmalloc.h anet.h zipmap.h ziplist.h intset.h version.h util.h \
  slowlog.h
sort.o: sort.c redis.h fmacros.h config.h ae.h sds.h dict.h adlist.h \
  zmalloc.h anet.h zipmap.h ziplist.h intset.h version.h util.h pqsort.h
syncio.o: syncio.c redis.h fmacros.h config.h ae.h sds.h dict.h adlist.h \
  zmalloc.h anet.h zipmap.h ziplist.h intset.h version.h util.h
t_hash.o: t_hash.c redis.h fmacros.h config.h ae.h sds.h dict.h adlist.h \
  zmalloc.h anet.h zipmap.h ziplist.h intset.h version.h util.h
t_list.o: t_list.c redis.h fmacros.h config.h ae.h sds.h dict.h adlist.h \
  zmalloc.h anet.h zipmap.h ziplist.h intset.h version.h util.h
t_set.o: t_set.c redis.h fmacros.h config.h ae.h sds.h dict.h adlist.h \
  zmalloc.h anet.h zipmap.h ziplist.h intset.h version.h util.h
t_string.o: t_string.c redis.h fmacros.h config.h ae.h sds.h dict.h \
  adlist.h zmalloc.h anet.h zipmap.h ziplist.h intset.h version.h util.h
t_zset.o: t_zset.c redis.h fmacros.h config.h ae.h sds.h dict.h adlist.h \
  zmalloc.h anet.h zipmap.h ziplist.h intset.h version.h util.h
util.o: util.c fmacros.h util.h
vm.o: vm.c redis.h fmacros.h config.h ae.h sds.h dict.h adlist.h \
  zmalloc.h anet.h zipmap.h ziplist.h intset.h version.h util.h
ziplist.o: ziplist.c zmalloc.h util.h ziplist.h endian.h
zipmap.o: zipmap.c zmalloc.h endian.h
zmalloc.o: zmalloc.c config.h zmalloc.h

.PHONY: dependencies

dependencies:
	@printf '%b %b\n' $(MAKECOLOR)MAKE$(ENDCOLOR) $(BINCOLOR)hiredis$(ENDCOLOR)
	@cd ../deps/hiredis && $(MAKE) static ARCH="$(ARCH)"
	@printf '%b %b\n' $(MAKECOLOR)MAKE$(ENDCOLOR) $(BINCOLOR)linenoise$(ENDCOLOR)
	@cd ../deps/linenoise && $(MAKE) ARCH="$(ARCH)"

../deps/jemalloc/lib/libjemalloc.a:
	@printf '%b %b\n' $(MAKECOLOR)MAKE$(ENDCOLOR) $(BINCOLOR)jemalloc$(ENDCOLOR)
	@cd ../deps/jemalloc && ./configure $(JEMALLOC_CFLAGS) --with-jemalloc-prefix=je_ --enable-cc-silence && $(MAKE) lib/libjemalloc.a

redis-benchmark.o:
	$(QUIET_CC)$(CC) -c $(CFLAGS) -I../deps/hiredis $(DEBUG) $(COMPILE_TIME) $<

redis-benchmark: dependencies $(BENCHOBJ)
	@printf '%b %b\n' $(MAKECOLOR)MAKE$(ENDCOLOR) $(BINCOLOR)hiredis$(ENDCOLOR)
	@cd ../deps/hiredis && $(MAKE) static ARCH="$(ARCH)"
	$(QUIET_LINK)$(CC) -o $(BENCHPRGNAME) $(CCOPT) $(DEBUG) $(BENCHOBJ) ../deps/hiredis/libhiredis.a $(CCLINK) $(ALLOC_LINK)

redis-cli.o:
	$(QUIET_CC)$(CC) -c $(CFLAGS) -I../deps/hiredis -I../deps/linenoise $(DEBUG) $(COMPILE_TIME) $<

redis-cli: dependencies $(CLIOBJ)
	$(QUIET_LINK)$(CC) -o $(CLIPRGNAME) $(CCOPT) $(DEBUG) $(CLIOBJ) ../deps/hiredis/libhiredis.a ../deps/linenoise/linenoise.o $(CCLINK) $(ALLOC_LINK)

redis-check-dump.o:
	$(QUIET_CC)$(CC) -c $(CFLAGS) $(DEBUG) $(COMPILE_TIME) $<

redis-check-dump: $(CHECKDUMPOBJ)
	$(QUIET_LINK)$(CC) -o $(CHECKDUMPPRGNAME) $(CCOPT) $(DEBUG) $(CHECKDUMPOBJ) $(CCLINK)

redis-check-aof.o:
	$(QUIET_CC)$(CC) -c $(CFLAGS) $(DEBUG) $(COMPILE_TIME) $<

redis-check-aof: $(CHECKAOFOBJ)
	$(QUIET_LINK)$(CC) -o $(CHECKAOFPRGNAME) $(CCOPT) $(DEBUG) $(CHECKAOFOBJ) $(CCLINK)

redis-server: $(OBJ)
	$(QUIET_LINK)$(CC) -o $(PRGNAME) $(CCOPT) $(DEBUG) $(OBJ) $(CCLINK) $(ALLOC_LINK)

# Because the jemalloc.h header is generated as a part of the jemalloc build
# process, building it should complete before building any other object.
%.o: %.c $(ALLOC_DEP)
	$(QUIET_CC)$(CC) -c $(CFLAGS) $(ALLOC_FLAGS) $(DEBUG) $(COMPILE_TIME) $<

clean:
	rm -rf $(PRGNAME) $(BENCHPRGNAME) $(CLIPRGNAME) $(CHECKDUMPPRGNAME) $(CHECKAOFPRGNAME) *.o *.gcda *.gcno *.gcov

distclean: clean
	-(cd .. && $(MAKE) clean)

dep:
	$(CC) -MM *.c -I ../deps/hiredis -I ../deps/linenoise

test: redis-server redis-check-aof
	@(cd ..; ./runtest)

bench:
	./redis-benchmark

log:
	git log '--pretty=format:%ad %s (%cn)' --date=short > ../Changelog

32bit:
	@echo ""
	@echo "WARNING: if it fails under Linux you probably need to install libc6-dev-i386"
	@echo ""
	$(MAKE) ARCH="-m32" JEMALLOC_CFLAGS='CFLAGS="-std=gnu99 -Wall -pipe -g3 -fvisibility=hidden -O3 -funroll-loops -m32"'

gprof:
	$(MAKE) PROF="-pg"

gcov:
	$(MAKE) PROF="-fprofile-arcs -ftest-coverage"

noopt:
	$(MAKE) OPTIMIZATION=""

32bitgprof:
	$(MAKE) PROF="-pg" ARCH="-arch i386"

install: all
	mkdir -p $(INSTALL_BIN)
	$(INSTALL) $(PRGNAME) $(INSTALL_BIN)
	$(INSTALL) $(BENCHPRGNAME) $(INSTALL_BIN)
	$(INSTALL) $(CLIPRGNAME) $(INSTALL_BIN)
	$(INSTALL) $(CHECKDUMPPRGNAME) $(INSTALL_BIN)
	$(INSTALL) $(CHECKAOFPRGNAME) $(INSTALL_BIN)

=== deps/linenoise/Makefile ===
linenoise_example: linenoise.h linenoise.c

linenoise_example: linenoise.o example.o
	$(CC) $(ARCH) -Wall -W -Os -g -o linenoise_example linenoise.o example.o

.c.o:
	$(CC) $(ARCH) -c -Wall -W -Os -g $<

clean:
	rm -f linenoise_example *.o

=== debian/changelog ===
redis (2:2.4.14-1) unstable; urgency=low

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Fri, 08 Jun 2012 17:21:49 +0100

redis (2:2.4.13-1) unstable; urgency=low

  * New upstream release. (Closes: #673202)
  * Sync upstream redis.conf changes with debian/redis.conf.

 -- Chris Lamb <lamby@debian.org>  Thu, 17 May 2012 10:32:33 +0100

redis (2:2.4.9-2) unstable; urgency=low

  * Add /etc/default/redis-server option to call ``ulimit -n'' before
    invoking Redis. (Closes: #672638)

 -- Chris Lamb <lamby@debian.org>  Mon, 14 May 2012 10:34:21 +0000

redis (2:2.4.9-1) unstable; urgency=low

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Mon, 26 Mar 2012 12:21:29 +0100

=== debian/control ===
Source: redis
Section: database
Priority: optional
Maintainer: Chris Lamb <lamby@debian.org>
Build-Depends: debhelper (>= 7.0.50), libjemalloc-dev
Standards-Version: 3.9.2
Homepage: http://redis.io/
Vcs-Git: git://github.com/lamby/pkg-redis.git
Vcs-Browser: https://github.com/lamby/pkg-redis

Package: redis-server
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, adduser
Description: Persistent key-value database with network interface
 Redis is a key-value database in a similar vein to memcache but the dataset
 is non-volatile. Redis additionally provides native support for atomically
 manipulating and querying data structures such as lists and sets.
 .
 The dataset is stored entirely in memory and periodically flushed to disk.

=== debian/watch ===
version=3
http://redis.io/download http://redis.googlecode.com/files/redis-(.*).tar.gz

## redis 2.4.15

=== debian/changelog ===
redis (2:2.4.15-1~bpo60+2) squeeze-backports; urgency=low

  * Rebuild without requiring libjemalloc-dev. Thanks to Jan Wagner
    <waja@cyconet.org>.

 -- Chris Lamb <lamby@debian.org>  Sun, 15 Jul 2012 16:49:16 -0700

redis (2:2.4.15-1~bpo60+1) squeeze-backports; urgency=low

  * Rebuild for squeeze-backports.

 -- Chris Lamb <lamby@debian.org>  Wed, 11 Jul 2012 10:17:53 +0100

redis (2:2.4.15-1) unstable; urgency=low

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Mon, 02 Jul 2012 10:56:28 +0100

redis (2:2.2.12-1~bpo60+1) squeeze-backports; urgency=low

  * Rebuild for squeeze-backports.

 -- Chris Lamb <lamby@debian.org>  Wed, 27 Jul 2011 19:40:37 +0200

redis (2:2.2.11-3~bpo60+1) squeeze-backports; urgency=low

  * Rebuild for squeeze-backports.

 -- Chris Lamb <lamby@debian.org>  Mon, 18 Jul 2011 13:31:34 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: database
 Priority: optional
 Maintainer: Chris Lamb <lamby@debian.org>
-Build-Depends: debhelper (>= 7.0.50), libjemalloc-dev
+Build-Depends: debhelper (>= 7.0.50)
 Standards-Version: 3.9.2
 Homepage: http://redis.io/
 Vcs-Git: git://github.com/lamby/pkg-redis.git

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,8 @@
 #!/usr/bin/make -f
 
 unexport CFLAGS
+
+export FORCE_LIBC_MALLOC = yes
 
 %:
 	dh $@

## redis 2.6.7

=== src/Makefile ===
# Redis Makefile
# Copyright (C) 2009 Salvatore Sanfilippo <antirez at gmail dot com>
# This file is released under the BSD license, see the COPYING file
#
# The Makefile composes the final FINAL_CFLAGS and FINAL_LDFLAGS using
# what is needed for Redis plus the standard CFLAGS and LDFLAGS passed.
# However when building the dependencies (Jemalloc, Lua, Hiredis, ...)
# CFLAGS and LDFLAGS are propagated to the dependencies, so to pass
# flags only to be used when compiling / linking Redis itself REDIS_CFLAGS
# and REDIS_LDFLAGS are used instead (this is the case of 'make gcov').
#
# Dependencies are stored in the Makefile.dep file. To rebuild this file
# Just use 'make dep', but this is only needed by developers.

release_hdr := $(shell sh -c './mkreleasehdr.sh')
uname_S := $(shell sh -c 'uname -s 2>/dev/null || echo not')
OPTIMIZATION?=-O2
DEPENDENCY_TARGETS=hiredis linenoise lua

# Default settings
STD= -std=c99 -pedantic
WARN= -Wall
OPT= $(OPTIMIZATION)

# Default allocator
ifeq ($(uname_S),Linux)
  MALLOC=jemalloc
else
  MALLOC=libc
endif

# Backwards compatibility for selecting an allocator
ifeq ($(USE_TCMALLOC),yes)
  MALLOC=tcmalloc
endif

ifeq ($(USE_TCMALLOC_MINIMAL),yes)
  MALLOC=tcmalloc_minimal
endif

ifeq ($(USE_JEMALLOC),yes)
  MALLOC=jemalloc
endif

# Override default settings if possible
-include .make-settings

ifeq ($(uname_S),SunOS)
  FINAL_CFLAGS= $(STD) $(WARN) $(OPT) $(DEBUG) $(CFLAGS) $(REDIS_CFLAGS) -D__EXTENSIONS__ -D_XPG6
  FINAL_LDFLAGS= $(LDFLAGS) $(REDIS_LDFLAGS) -g -ggdb
  FINAL_LIBS= -ldl -lnsl -lsocket -lm -lpthread
  DEBUG= -g -ggdb
else
  FINAL_CFLAGS= $(STD) $(WARN) $(OPT) $(DEBUG) $(CFLAGS) $(REDIS_CFLAGS)
  FINAL_LDFLAGS= $(LDFLAGS) $(REDIS_LDFLAGS) -g -rdynamic -ggdb
  FINAL_LIBS= -lm -pthread
  DEBUG= -g -rdynamic -ggdb
endif

# Include paths to dependencies
FINAL_CFLAGS+= -I../deps/hiredis -I../deps/linenoise -I../deps/lua/src

ifeq ($(MALLOC),tcmalloc)
  FINAL_CFLAGS+= -DUSE_TCMALLOC
  FINAL_LIBS+= -ltcmalloc
endif

ifeq ($(MALLOC),tcmalloc_minimal)
  FINAL_CFLAGS+= -DUSE_TCMALLOC
  FINAL_LIBS+= -ltcmalloc_minimal
endif

ifeq ($(MALLOC),jemalloc)
  DEPENDENCY_TARGETS+= jemalloc
  FINAL_CFLAGS+= -DUSE_JEMALLOC -I../deps/jemalloc/include
  FINAL_LIBS+= ../deps/jemalloc/lib/libjemalloc.a -ldl
endif

REDIS_CC=$(QUIET_CC)$(CC) $(FINAL_CFLAGS)
REDIS_LD=$(QUIET_LINK)$(CC) $(FINAL_LDFLAGS)
REDIS_INSTALL=$(QUIET_INSTALL)$(INSTALL)

PREFIX?=/usr/local
INSTALL_BIN= $(PREFIX)/bin
INSTALL= cp -pf

CCCOLOR="\033[34m"
LINKCOLOR="\033[34;1m"
SRCCOLOR="\033[33m"
BINCOLOR="\033[37;1m"
MAKECOLOR="\033[32;1m"
ENDCOLOR="\033[0m"

ifndef V
QUIET_CC = @printf '    %b %b\n' $(CCCOLOR)CC$(ENDCOLOR) $(SRCCOLOR)$@$(ENDCOLOR) 1>&2;
QUIET_LINK = @printf '    %b %b\n' $(LINKCOLOR)LINK$(ENDCOLOR) $(BINCOLOR)$@$(ENDCOLOR) 1>&2;
QUIET_INSTALL = @printf '    %b %b\n' $(LINKCOLOR)INSTALL$(ENDCOLOR) $(BINCOLOR)$@$(ENDCOLOR) 1>&2;
endif

REDIS_SERVER_NAME= redis-server
REDIS_SENTINEL_NAME= redis-sentinel
REDIS_SERVER_OBJ= adlist.o ae.o anet.o dict.o redis.o sds.o zmalloc.o lzf_c.o lzf_d.o pqsort.o zipmap.o sha1.o ziplist.o release.o networking.o util.o object.o db.o replication.o rdb.o t_string.o t_list.o t_set.o t_zset.o t_hash.o config.o aof.o pubsub.o multi.o debug.o sort.o intset.o syncio.o migrate.o endianconv.o slowlog.o scripting.o bio.o rio.o rand.o memtest.o crc64.o bitops.o sentinel.o
REDIS_CLI_NAME= redis-cli
REDIS_CLI_OBJ= anet.o sds.o adlist.o redis-cli.o zmalloc.o release.o anet.o ae.o
REDIS_BENCHMARK_NAME= redis-benchmark
REDIS_BENCHMARK_OBJ= ae.o anet.o redis-benchmark.o sds.o adlist.o zmalloc.o redis-benchmark.o
REDIS_CHECK_DUMP_NAME= redis-check-dump
REDIS_CHECK_DUMP_OBJ= redis-check-dump.o lzf_c.o lzf_d.o crc64.o
REDIS_CHECK_AOF_NAME= redis-check-aof
REDIS_CHECK_AOF_OBJ= redis-check-aof.o

all: $(REDIS_SERVER_NAME) $(REDIS_SENTINEL_NAME) $(REDIS_CLI_NAME) $(REDIS_BENCHMARK_NAME) $(REDIS_CHECK_DUMP_NAME) $(REDIS_CHECK_AOF_NAME)
	@echo ""
	@echo "Hint: To run 'make test' is a good idea ;)"
	@echo ""

.PHONY: all

# Deps (use make dep to generate this)
include Makefile.dep

dep:
	$(REDIS_CC) -MM *.c > Makefile.dep

.PHONY: dep

persist-settings: distclean
	echo STD=$(STD) >> .make-settings
	echo WARN=$(WARN) >> .make-settings
	echo OPT=$(OPT) >> .make-settings
	echo MALLOC=$(MALLOC) >> .make-settings
	echo CFLAGS=$(CFLAGS) >> .make-settings
	echo LDFLAGS=$(LDFLAGS) >> .make-settings
	echo REDIS_CFLAGS=$(REDIS_CFLAGS) >> .make-settings
	echo REDIS_LDFLAGS=$(REDIS_LDFLAGS) >> .make-settings
	echo PREV_FINAL_CFLAGS=$(FINAL_CFLAGS) >> .make-settings
	echo PREV_FINAL_LDFLAGS=$(FINAL_LDFLAGS) >> .make-settings
	-(cd ../deps && $(MAKE) $(DEPENDENCY_TARGETS))

.PHONY: persist-settings

# Prerequisites target
.make-prerequisites:
	@touch $@

# Clean everything, persist settings and build dependencies if anything changed
ifneq ($(strip $(PREV_FINAL_CFLAGS)), $(strip $(FINAL_CFLAGS)))
.make-prerequisites: persist-settings
endif

ifneq ($(strip $(PREV_FINAL_LDFLAGS)), $(strip $(FINAL_LDFLAGS)))
.make-prerequisites: persist-settings
endif

# redis-server
$(REDIS_SERVER_NAME): $(REDIS_SERVER_OBJ)
	$(REDIS_LD) -o $@ $^ ../deps/hiredis/libhiredis.a ../deps/lua/src/liblua.a $(FINAL_LIBS)

# redis-sentinel
$(REDIS_SENTINEL_NAME): $(REDIS_SERVER_NAME)
	$(REDIS_INSTALL) $(REDIS_SERVER_NAME) $(REDIS_SENTINEL_NAME)

# redis-cli
$(REDIS_CLI_NAME): $(REDIS_CLI_OBJ)
	$(REDIS_LD) -o $@ $^ ../deps/hiredis/libhiredis.a ../deps/linenoise/linenoise.o $(FINAL_LIBS)

# redis-benchmark
$(REDIS_BENCHMARK_NAME): $(REDIS_BENCHMARK_OBJ)
	$(REDIS_LD) -o $@ $^ ../deps/hiredis/libhiredis.a $(FINAL_LIBS)

# redis-check-dump
$(REDIS_CHECK_DUMP_NAME): $(REDIS_CHECK_DUMP_OBJ)
	$(REDIS_LD) -o $@ $^ $(FINAL_LIBS)

# redis-check-aof
$(REDIS_CHECK_AOF_NAME): $(REDIS_CHECK_AOF_OBJ)
	$(REDIS_LD) -o $@ $^ $(FINAL_LIBS)

# Because the jemalloc.h header is generated as a part of the jemalloc build,
# building it should complete before building any other object. Instead of
# depending on a single artifact, build all dependencies first.
%.o: %.c .make-prerequisites
	$(REDIS_CC) -c $<

clean:
	rm -rf $(REDIS_SERVER_NAME) $(REDIS_SENTINEL_NAME) $(REDIS_CLI_NAME) $(REDIS_BENCHMARK_NAME) $(REDIS_CHECK_DUMP_NAME) $(REDIS_CHECK_AOF_NAME) *.o *.gcda *.gcno *.gcov redis.info lcov-html

.PHONY: clean

distclean: clean
	-(cd ../deps && $(MAKE) distclean)
	-(rm -f .make-*)

.PHONY: distclean

test: $(REDIS_SERVER_NAME) $(REDIS_CHECK_AOF_NAME)
	@(cd ..; ./runtest)

lcov:
	$(MAKE) gcov
	@(set -e; cd ..; ./runtest --clients 1)
	@geninfo -o redis.info .
	@genhtml --legend -o lcov-html redis.info

.PHONY: lcov

bench: $(REDIS_BENCHMARK_NAME)
	./$(REDIS_BENCHMARK_NAME)

32bit:
	@echo ""
	@echo "WARNING: if it fails under Linux you probably need to install libc6-dev-i386"
	@echo ""
	$(MAKE) CFLAGS="-m32" LDFLAGS="-m32"

gcov:
	$(MAKE) REDIS_CFLAGS="-fprofile-arcs -ftest-coverage -DCOVERAGE_TEST" REDIS_LDFLAGS="-fprofile-arcs -ftest-coverage"

noopt:
	$(MAKE) OPT="-O0"

src/help.h:
	@../utils/generate-command-help.rb > help.h

install: all
	mkdir -p $(INSTALL_BIN)
	$(REDIS_INSTALL) $(REDIS_SERVER_NAME) $(INSTALL_BIN)
	$(REDIS_INSTALL) $(REDIS_BENCHMARK_NAME) $(INSTALL_BIN)
	$(REDIS_INSTALL) $(REDIS_CLI_NAME) $(INSTALL_BIN)
	$(REDIS_INSTALL) $(REDIS_CHECK_DUMP_NAME) $(INSTALL_BIN)
	$(REDIS_INSTALL) $(REDIS_CHECK_AOF_NAME) $(INSTALL_BIN)

=== debian/changelog ===
redis (2:2.6.7-1) unstable; urgency=low

  * New upstream release.
  * Add missing "status" command from usage. Thanks to Dererk
    <dererk@debian.org>. (Closes: #696339)
  * Enable building on kfreebsd-amd64 (and possibly kfreebsd-i386 and
    hurd-i386) by not depending on 'jemalloc' which would not be used anyway.
    Thanks to Jeff Epler <jepler@unpythonic.net>. (Closes: #696618)

 -- Chris Lamb <lamby@debian.org>  Fri, 28 Dec 2012 17:00:06 +0000

redis (2:2.6.0-1) unstable; urgency=low

  * New upstream release.
  * Update 02-fix-ftbfs-on-kfreebsd.diff.
  * Update 03-use-system-jemalloc.diff.
  * Update configuration file.

 -- Chris Lamb <lamby@debian.org>  Tue, 23 Oct 2012 15:04:17 +0100

redis (2:2.4.17-1) unstable; urgency=low

  * New upstream release.
  * Bump Standards-Version to 3.9.3.

 -- Chris Lamb <lamby@debian.org>  Wed, 10 Oct 2012 21:16:47 +0100

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: database
 Priority: optional
 Maintainer: Chris Lamb <lamby@debian.org>
-Build-Depends: debhelper (>= 7.0.50)
-Standards-Version: 3.9.2
+Build-Depends: debhelper (>= 7.0.50), libjemalloc-dev [linux-any]
+Standards-Version: 3.9.3
 Homepage: http://redis.io/
 Vcs-Git: git://github.com/lamby/pkg-redis.git
 Vcs-Browser: https://github.com/lamby/pkg-redis

## redis 2.6.13

=== debian/changelog ===
redis (2:2.6.13-1) unstable; urgency=low

  * New upstream release.
    - Sync debian/redis.conf.
    - Update 02-fix-ftbfs-on-kfreebsd.diff.

 -- Chris Lamb <lamby@debian.org>  Mon, 17 Jun 2013 00:49:42 +0100

## redis 2.6.14

=== debian/changelog ===
redis (2:2.6.14-2uk1) unstable; urgency=low

  * precise backport

 -- Albrecht Gebhardt <albrecht.gebhardt@uni-klu.ac.at>  Thu, 05 Sep 2013 15:15:53 +0000

redis (2:2.6.14-2) unstable; urgency=low

  * Source /lib/lsb/init-functions in initscript for systemd compatibility.

 -- Chris Lamb <lamby@debian.org>  Mon, 12 Aug 2013 16:17:47 +0100

redis (2:2.6.14-1) unstable; urgency=low

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Tue, 06 Aug 2013 12:14:12 +0100
